/*	
 *	bltml.h
 *
 *	BulletML
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2006 Naoyuki Sawa
 *
 *	* Mon Dec 04 18:17:17 JST 2006 Naoyuki Sawa
 *	- 1st [XB
 *	  RgȂ̂ŁÂƏ\łB
 */
#ifndef __BLTML_H__
#define __BLTML_H__

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _BulletMLBase BulletMLBase;
/**/typedef struct _BulletMLNode BulletMLNode;
/**/typedef struct _BulletMLBullet BulletMLBullet;
/**/typedef struct _BulletMLAction BulletMLAction;
/**/typedef struct _BulletMLValue BulletMLValue;
/*@@@*/typedef struct _BulletMLNumber BulletMLNumber;
/*@@@*/typedef struct _BulletMLVar BulletMLVar;
/*@@@*/typedef struct _BulletMLUnExpr BulletMLUnExpr;
/*@@@*/typedef struct _BulletMLBinExpr BulletMLBinExpr;

typedef struct _BulletMLBase_vtbl BulletMLBase_vtbl;
/**/typedef struct _BulletMLNode_vtbl BulletMLNode_vtbl;
/**/typedef struct _BulletMLBullet_vtbl BulletMLBullet_vtbl;
/**/typedef struct _BulletMLAction_vtbl BulletMLAction_vtbl;
/**/typedef struct _BulletMLValue_vtbl BulletMLValue_vtbl;
/*@@@*/typedef struct _BulletMLNumber_vtbl BulletMLNumber_vtbl;
/*@@@*/typedef struct _BulletMLVar_vtbl BulletMLVar_vtbl;
/*@@@*/typedef struct _BulletMLUnExpr_vtbl BulletMLUnExpr_vtbl;
/*@@@*/typedef struct _BulletMLBinExpr_vtbl BulletMLBinExpr_vtbl;

static inline BulletMLBase * BulletMLNode_super   (BulletMLNode   * This) { return (BulletMLBase *)This; }
static inline BulletMLBase * BulletMLBullet_super (BulletMLBullet * This) { return (BulletMLBase *)This; }
static inline BulletMLBase * BulletMLAction_super (BulletMLAction * This) { return (BulletMLBase *)This; }
static inline BulletMLBase * BulletMLValue_super  (BulletMLValue  * This) { return (BulletMLBase *)This; }
static inline BulletMLValue* BulletMLNumber_super (BulletMLNumber * This) { return (BulletMLValue*)This; }
static inline BulletMLValue* BulletMLVar_super    (BulletMLVar    * This) { return (BulletMLValue*)This; }
static inline BulletMLValue* BulletMLUnExpr_super (BulletMLUnExpr * This) { return (BulletMLValue*)This; }
static inline BulletMLValue* BulletMLBinExpr_super(BulletMLBinExpr* This) { return (BulletMLValue*)This; }

/* BulletMLNode.name */
enum {
	BULLETMLNODE_NAME_BULLETML,
	BULLETMLNODE_NAME_BULLET,
	BULLETMLNODE_NAME_ACTION,
	BULLETMLNODE_NAME_FIRE,
	BULLETMLNODE_NAME_CHANGEDIRECTION,
	BULLETMLNODE_NAME_CHANGESPEED,
	BULLETMLNODE_NAME_ACCEL,
	BULLETMLNODE_NAME_WAIT,
	BULLETMLNODE_NAME_VANISH,
	BULLETMLNODE_NAME_REPEAT,
	BULLETMLNODE_NAME_DIRECTION,
	BULLETMLNODE_NAME_SPEED,
	BULLETMLNODE_NAME_HORIZONTAL,
	BULLETMLNODE_NAME_VERTICAL,
	BULLETMLNODE_NAME_TERM,
	BULLETMLNODE_NAME_TIMES,
	BULLETMLNODE_NAME_BULLETREF,
	BULLETMLNODE_NAME_ACTIONREF,
	BULLETMLNODE_NAME_FIREREF,
	BULLETMLNODE_NAME_PARAM,
	BULLETMLNODE_NAME_COUNT,
};

/* BulletMLNode.type */
enum {
	BULLETMLNODE_TYPE_NONE,		/* bulletml */
	BULLETMLNODE_TYPE_VERTICAL,	/* bulletml */
	BULLETMLNODE_TYPE_HORIZONTAL,	/* bulletml */
	BULLETMLNODE_TYPE_AIM,		/* direction */
	BULLETMLNODE_TYPE_ABSOLUTE,	/* direction,speed,horizontal,vertical */
	BULLETMLNODE_TYPE_RELATIVE,	/* direction,speed,horizontal,vertical */
	BULLETMLNODE_TYPE_SEQUENCE,	/* direction,speed,horizontal,vertical */
	BULLETMLNODE_TYPE_COUNT,
};

#define BULLETML_MAX_PARAMS	9

/****************************************************************************
 *	BulletML_load
 ****************************************************************************/

BulletMLNode* BulletML_load(const char* filename_or_xmltext);

/****************************************************************************
 *	BulletMLBase
 ****************************************************************************/

struct _BulletMLBase {
	const BulletMLBase_vtbl* vptr;
	/*BulletMLBase*/
};

struct _BulletMLBase_vtbl {
	void (*destruct)(BulletMLBase* This);
	/*BulletMLBase_vtbl*/
};

//BulletMLBase* BulletMLBase_new(); hNX̂ݐ
void BulletMLBase_delete(BulletMLBase* This);
void _BulletMLBase_construct(BulletMLBase* This);
/*virtual*/ void _BulletMLBase_destruct(BulletMLBase* This);

/****************************************************************************
 *	BulletMLNode
 ****************************************************************************/

struct _BulletMLNode /*:BulletMLBase*/ {
	const BulletMLNode_vtbl* vptr;
	/*BulletMLBase*/
	int name;
	int type;		/* bulletml,direction,speed,horizontal,vertical */
	StdString* label;	/* bullet,bulletRef,action,actionRef,fire,fireRef */
	BulletMLNode* ref;	/* bulletRef,actionRef,fireRef */
	BulletMLValue* value;
	BulletMLNode* parent;
	BulletMLNode* firstChild;
	BulletMLNode* nextSibling;
	/*BulletMLNode*/
};

struct _BulletMLNode_vtbl {
	void (*destruct)(BulletMLNode* This);
	/*BulletMLBase_vtbl*/
	/*BulletMLNode_vtbl*/
};

BulletMLNode* BulletMLNode_new(const char* name);
void BulletMLNode_delete(BulletMLNode* This);
void _BulletMLNode_construct(BulletMLNode* This, const char* name);
/*virtual*/ void _BulletMLNode_destruct(BulletMLNode* This);
/*public:*/
int BulletMLNode_getName(BulletMLNode* This);
void BulletMLNode_setType(BulletMLNode* This, const char* type);
int BulletMLNode_getType(BulletMLNode* This);
void BulletMLNode_setLabel(BulletMLNode* This, const char* label);
const char* BulletMLNode_getLabel(BulletMLNode* This);
void BulletMLNode_setRef(BulletMLNode* This, BulletMLNode* ref);
BulletMLNode* BulletMLNode_getRef(BulletMLNode* This);
void BulletMLNode_setValue(BulletMLNode* This, const char* value);
BulletMLValue* BulletMLNode_getValue(BulletMLNode* This);
BulletMLNode* BulletMLNode_getParent(BulletMLNode* This);
BulletMLNode* BulletMLNode_firstChild(BulletMLNode* This);
BulletMLNode* BulletMLNode_nextSibling(BulletMLNode* This);
void BulletMLNode_addChild(BulletMLNode* This, BulletMLNode* child);
BulletMLNode* BulletMLNode_getChild(BulletMLNode* This, int name);
void BulletMLNode_dump(BulletMLNode* This, int indent);

/****************************************************************************
 *	BulletMLBullet
 ****************************************************************************/

typedef struct _BulletMLUserFunc {
	void (*createBullet)(void* userData, fixed direction, fixed speed, BulletMLNode* bulletNode, const fixed params[/*BULLETML_MAX_PARAMS*/]);
	void (*setDirection)(void* userData, fixed direction);
	void (*setSpeed)(void* userData, fixed speed);
	void (*setAccelH)(void* userData, fixed accelH);
	void (*setAccelV)(void* userData, fixed accelV);
	void (*vanish)(void* userData);
	fixed (*getRand)(void* userData);
	fixed (*getRank)(void* userData);
	fixed (*getAimDirection)(void* userData);
	fixed (*getDirection)(void* userData);
	fixed (*getSpeed)(void* userData);
	fixed (*getAccelH)(void* userData);
	fixed (*getAccelV)(void* userData);
} BulletMLUserFunc;

typedef struct _BulletMLChange {
	/* <changeDirection|changeSpeed|accel>p */
	fixed start;	/* l */
	fixed diff;	/* ω */
	int term;	/*  */
	int cnt;	/* oߎ */
	/* <direction|speed|horizontal|vertical type="sequence">p */
	fixed prev;	/* Ol */
} BulletMLChange;

struct _BulletMLBullet /*:BulletMLBase*/ {
	const BulletMLBullet_vtbl* vptr;
	/*BulletMLBase*/
	const BulletMLUserFunc* userFunc;
	void* userData;
	fixed params[BULLETML_MAX_PARAMS];
	BulletMLChange direction;
	BulletMLChange speed;
	BulletMLChange accelH;
	BulletMLChange accelV;
	BulletMLAction* firstAction;	/* <bullet>ɕ̎q<action>ꍇASēɋNs삵܂ */
	/*BulletMLBullet*/
};

struct _BulletMLBullet_vtbl {
	void (*destruct)(BulletMLBullet* This);
	/*BulletMLBase_vtbl*/
	/*BulletMLBullet_vtbl*/
};

BulletMLBullet* BulletMLBullet_new(const BulletMLUserFunc* userFunc, void* userData, BulletMLNode* bulletNode, const fixed params[/*BULLETML_MAX_PARAMS*/]/*NULL*/);
void BulletMLBullet_delete(BulletMLBullet* This);
void _BulletMLBullet_construct(BulletMLBullet* This, const BulletMLUserFunc* userFunc, void* userData, BulletMLNode* bulletNode, const fixed params[/*BULLETML_MAX_PARAMS*/]/*NULL*/);
/*virtual*/ void _BulletMLBullet_destruct(BulletMLBullet* This);
/*public:*/
const BulletMLUserFunc* BulletMLBullet_getUserFunc(BulletMLBullet* This);
void* BulletMLBullet_getUserData(BulletMLBullet* This);
int BulletMLBullet_run(BulletMLBullet* This);

/****************************************************************************
 *	BulletMLAction
 ****************************************************************************/

struct _BulletMLAction /*:BulletMLBase*/ {
	const BulletMLAction_vtbl* vptr;
	/*BulletMLBase*/
	fixed params[BULLETML_MAX_PARAMS];
	BulletMLBullet* bullet;		/* <action>e<bullet> */
	BulletMLNode* pc;
	int wait;			/* <wait>p */
	int repeat;			/* <repeat><times>p */
	BulletMLAction* childAction;	/* <action>ɕ̎q<action>ꍇA̗vfƓlɒ삵܂ */
	BulletMLAction* nextSibling;	/* <bullet>̎̕q<action>̃Np */
	/*BulletMLAction*/
};

struct _BulletMLAction_vtbl {
	void (*destruct)(BulletMLAction* This);
	/*BulletMLBase_vtbl*/
	/*BulletMLAction_vtbl*/
};

BulletMLAction* BulletMLAction_new(BulletMLBullet* bullet, BulletMLNode* actionNode, const fixed params[/*BULLETML_MAX_PARAMS*/]);
void BulletMLAction_delete(BulletMLAction* This);
void _BulletMLAction_construct(BulletMLAction* This, BulletMLBullet* bullet, BulletMLNode* actionNode, const fixed params[/*BULLETML_MAX_PARAMS*/]);
/*virtual*/ void _BulletMLAction_destruct(BulletMLAction* This);
/*public:*/
int BulletMLAction_run(BulletMLAction* This);

/****************************************************************************
 *	BulletMLValue
 ****************************************************************************/

struct _BulletMLValue /*:BulletMLBase*/ {
	const BulletMLValue_vtbl* vptr;
	/*BulletMLBase*/
	/*BulletMLValue*/
};

struct _BulletMLValue_vtbl {
	void (*destruct)(BulletMLValue* This);
	/*BulletMLBase_vtbl*/
	fixed (*calc)(BulletMLValue* This, const fixed params[/*BULLETML_MAX_PARAMS*/], const BulletMLUserFunc* userFunc, void* userData); /*=0*/
	void (*dump)(BulletMLValue* This); /*=0*/
	/*BulletMLValue_vtbl*/
};

//BulletMLValue* BulletMLValue_new(); hNX̂ݐ
void BulletMLValue_delete(BulletMLValue* This);
void _BulletMLValue_construct(BulletMLValue* This);
/*virtual*/ void _BulletMLValue_destruct(BulletMLValue* This);

/****************************************************************************
 *	BulletMLNumber
 ****************************************************************************/

struct _BulletMLNumber /*:BulletMLValue*/ {
	const BulletMLNumber_vtbl* vptr;
	/*BulletMLBase*/
	/*BulletMLValue*/
	fixed value;
	/*BulletMLNumber*/
};

struct _BulletMLNumber_vtbl {
	void (*destruct)(BulletMLNumber* This);
	/*BulletMLBase_vtbl*/
	fixed (*calc)(BulletMLNumber* This, const fixed params[/*BULLETML_MAX_PARAMS*/], const BulletMLUserFunc* userFunc, void* userData);
	void (*dump)(BulletMLNumber* This);
	/*BulletMLValue_vtbl*/
	/*BulletMLNumber_vtbl*/
};

BulletMLNumber* BulletMLNumber_new(const char** pp);
void BulletMLNumber_delete(BulletMLNumber* This);
void _BulletMLNumber_construct(BulletMLNumber* This, const char** pp);
/*virtual*/ void _BulletMLNumber_destruct(BulletMLNumber* This);
/*public:*/
/*virtual*/ fixed _BulletMLNumber_calc(BulletMLNumber* This, const fixed params[/*BULLETML_MAX_PARAMS*/], const BulletMLUserFunc* userFunc, void* userData);
/*virtual*/ void _BulletMLNumber_dump(BulletMLNumber* This);

/****************************************************************************
 *	BulletMLVar
 ****************************************************************************/

struct _BulletMLVar /*:BulletMLValue*/ {
	const BulletMLVar_vtbl* vptr;
	/*BulletMLBase*/
	/*BulletMLValue*/
	int id;			/* -1 = $rand, -2 = $rank, 1`9 = $1`$9 */
	/*BulletMLVar*/
};

struct _BulletMLVar_vtbl {
	void (*destruct)(BulletMLVar* This);
	/*BulletMLBase_vtbl*/
	fixed (*calc)(BulletMLVar* This, const fixed params[/*BULLETML_MAX_PARAMS*/], const BulletMLUserFunc* userFunc, void* userData);
	void (*dump)(BulletMLVar* This);
	/*BulletMLValue_vtbl*/
	/*BulletMLVar_vtbl*/
};

BulletMLVar* BulletMLVar_new(const char** pp);
void BulletMLVar_delete(BulletMLVar* This);
void _BulletMLVar_construct(BulletMLVar* This, const char** pp);
/*virtual*/ void _BulletMLVar_destruct(BulletMLVar* This);
/*public:*/
/*virtual*/ fixed _BulletMLVar_calc(BulletMLVar* This, const fixed params[/*BULLETML_MAX_PARAMS*/], const BulletMLUserFunc* userFunc, void* userData);
/*virtual*/ void _BulletMLVar_dump(BulletMLVar* This);

/****************************************************************************
 *	BulletMLUnExpr
 ****************************************************************************/

struct _BulletMLUnExpr /*:BulletMLValue*/ {
	const BulletMLUnExpr_vtbl* vptr;
	/*BulletMLBase*/
	/*BulletMLValue*/
	int op;
	BulletMLValue* value;
	/*BulletMLUnExpr*/
};

struct _BulletMLUnExpr_vtbl {
	void (*destruct)(BulletMLUnExpr* This);
	/*BulletMLBase_vtbl*/
	fixed (*calc)(BulletMLUnExpr* This, const fixed params[/*BULLETML_MAX_PARAMS*/], const BulletMLUserFunc* userFunc, void* userData);
	void (*dump)(BulletMLUnExpr* This);
	/*BulletMLValue_vtbl*/
	/*BulletMLUnExpr_vtbl*/
};

BulletMLUnExpr* BulletMLUnExpr_new(int op, BulletMLValue* value);
void BulletMLUnExpr_delete(BulletMLUnExpr* This);
void _BulletMLUnExpr_construct(BulletMLUnExpr* This, int op, BulletMLValue* value);
/*virtual*/ void _BulletMLUnExpr_destruct(BulletMLUnExpr* This);
/*public:*/
/*virtual*/ fixed _BulletMLUnExpr_calc(BulletMLUnExpr* This, const fixed params[/*BULLETML_MAX_PARAMS*/], const BulletMLUserFunc* userFunc, void* userData);
/*virtual*/ void _BulletMLUnExpr_dump(BulletMLUnExpr* This);

/****************************************************************************
 *	BulletMLBinExpr
 ****************************************************************************/

struct _BulletMLBinExpr /*:BulletMLValue*/ {
	const BulletMLBinExpr_vtbl* vptr;
	/*BulletMLBase*/
	/*BulletMLValue*/
	int op;
	BulletMLValue* lhs;
	BulletMLValue* rhs;
	/*BulletMLBinExpr*/
};

struct _BulletMLBinExpr_vtbl {
	void (*destruct)(BulletMLBinExpr* This);
	/*BulletMLBase_vtbl*/
	fixed (*calc)(BulletMLBinExpr* This, const fixed params[/*BULLETML_MAX_PARAMS*/], const BulletMLUserFunc* userFunc, void* userData);
	void (*dump)(BulletMLBinExpr* This);
	/*BulletMLValue_vtbl*/
	/*BulletMLBinExpr_vtbl*/
};

BulletMLBinExpr* BulletMLBinExpr_new(int op, BulletMLValue* lhs, BulletMLValue* rhs);
void BulletMLBinExpr_delete(BulletMLBinExpr* This);
void _BulletMLBinExpr_construct(BulletMLBinExpr* This, int op, BulletMLValue* lhs, BulletMLValue* rhs);
/*virtual*/ void _BulletMLBinExpr_destruct(BulletMLBinExpr* This);
/*public:*/
/*virtual*/ fixed _BulletMLBinExpr_calc(BulletMLBinExpr* This, const fixed params[/*BULLETML_MAX_PARAMS*/], const BulletMLUserFunc* userFunc, void* userData);
/*virtual*/ void _BulletMLBinExpr_dump(BulletMLBinExpr* This);

#endif /*__BLTML_H__*/
