/*
 *	app.h
 *
 *	dppcmcnv - WAV to PPD Ro[^
 *	Copyright (C) 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *
 *	* Sun Jul 21 04:37:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#define STRICT
#include <windows.h>
#include <mmreg.h>
#include <msacm.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "msacm32.lib")

#define VERSION		"20060717"

/* piece.h (BIOS 1.18)  */
#define PW_TYPE_8BITPCM		0
#define PW_TYPE_16BITPCM	1
#define PW_TYPE_4BITADPCM	2
#define PW_TYPE_CONT		0x10	/* Ao */
#define PW_TYPE_ADP_INI		0x20	/* ADPCMv */
#define PW_TYPE_VR		0x40	/* σ[g */
#define PW_TYPE_ADPCM		(PW_TYPE_4BITADPCM|PW_TYPE_ADP_INI)
#define PW_TYPE_ADPCM_V		(PW_TYPE_4BITADPCM|PW_TYPE_VR|PW_TYPE_ADP_INI)
#define PW_TYPE_ADPCM_NI	(PW_TYPE_4BITADPCM)
#define PW_TYPE_ADPCM_V_NI	(PW_TYPE_4BITADPCM|PW_TYPE_VR)
#define PW_STAT_START		1	/* ĐJn */
#define PW_STAT_END		2	/* ĐI */
typedef struct tagPCEWAVEINFO {				/*    sł...	t@Cł... */
	volatile unsigned char stat;			/*  0 Xe[^X		PW_STAT_STARTŒ */
	unsigned char type;				/*  1 f[^`		()            */
	unsigned short resv;				/*  2 0܂͎g(ADPCM_V)	()            */
	const void* pData;				/*  4 f[^ւ̃|C^	NULL              */
	unsigned long len;				/*  8 f[^̒(Tv)	()            */
	struct tagPCEWAVEINFO *next;			/* 12 ւ̃|C^		NULL              */
	void (*pfEndProc)(struct tagPCEWAVEINFO*);	/* 16 IR[obN	NULL              */
} PCEWAVEINFO;

/* t@Cł́APCEWAVEINFȎOɃVOl`ƃTCYu܂B
 * u"P/ECE" Official WebPage JҌfvɂāǍɊւ鎿^܂B
 * ÔߕۑĂ̂ŁAukeep/wavf[^̍Đɂ.txtvQƂĂB
 */
#define PPDSIG		((int)'PPCM')
typedef struct _PPDHDR {
	int sig;	/* 'PPCM'Œ                   */
	int len;	/* PPDHDRt@CTCY */
} PPDHDR;

// wav.c
typedef struct WAV {
	WAVEFORMATEX* fmt;	/* tH[}bg         */
	int c_data;		/* f[^TCY[oCg] */
	char* data;		/* f[^               */
} WAV;
WAV* wav_new();
void wav_free(WAV* wav);
WAV* wav_load(const char* path);
void wav_to_wav(WAV* wav1, WAV* wav2);

// wav2adpc.c
void encode(unsigned char *adp,signed short *wave,int size);

// main.c
void usage();
void die(const char* fmt, ...);
void cmdline(int argc, char* argv[]);
void writedata(FILE* fp, void* data, int len);
void writepcm(FILE* fp, WAV* wav);
void writeadpcm(FILE* fp, WAV* wav);

#endif /*__APP_H__*/
