/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_ship.c
 *  Content	:@ANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/2/2
 *  UpDate	:2004/3/21
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

#define DIR_ONE	(4.0f)
#define DIR_R2	(1.41421356f)
#define DIR_X	(DIR_ONE / (1.0f / DIR_R2))
#define DIR_Y	(DIR_ONE / (1.0f / DIR_R2))
#define DIR_XY	(DIR_ONE)

#define KEYDIR	(PAD_INPUT_DOWN|PAD_INPUT_LEFT|PAD_INPUT_RIGHT|PAD_INPUT_UP)

static const float mov_tbl[][2] = {
	{ +0     ,+0      },	/* none        */
	{ +0     ,+DIR_Y  },	/* DN          */
	{ -DIR_X ,+0      },	/*    LF       */
	{ -DIR_XY,+DIR_XY },	/* DN LF       */
	{ +DIR_X ,+0      },	/*       RI    */
	{ +DIR_XY,+DIR_XY },	/* DN    RI    */
	{ +0     ,+0      },	/*    LF RI    */
	{ +0     ,+0      },	/* DN LF RI    */
	{ +0     ,-DIR_Y  },	/*          UP */
	{ +0     ,+0      },	/* DN       UP */
	{ -DIR_XY,-DIR_XY },	/*    LF    UP */
	{ +0     ,+0      },	/* DN LF    UP */
	{ +DIR_XY,-DIR_XY },	/*       RI UP */
	{ +0     ,+0      },	/* DN    RI UP */
	{ +0     ,+0      },	/*    LF RI UP */
	{ +0     ,+0      },	/* DN LF RI UP */
};

static int shot_level;
static int shot_cnt;
static int shot_max;
static int shot_wait;
static int shot_bomb;

static void actShipInt(ACT* actp);
static void actShipBullet(ACT* actp);
static void actShipBulletInt(ACT* actp);
static void actShipBomb(ACT* actp);
static void actSetExplode(ACT* actp);
static void actExplode(ACT* actp);
static void actShipParticle(ACT* actp);
static void actSetShipParticle(ACT* actp);

void
actShip(ACT* actp)
{
	int pos[XY];
	int keydir;
	int keydat;
	ACT* eactp;
	int color;

	switch(actp->step) {
	/*  */
	case 0:
		BulletMLsetShipAct(actp);
		actp->actid = ACTF_SHIP;
		//actp->col[X] = 2.0f;
		//actp->col[Y] = 2.0f;
		//Sat Dec 09 18:08:52 JST 2006 Naoyuki Sawa
		actp->col[X] = 8.0f;
		actp->col[Y] = 8.0f;
		actp->int_adr = actShipInt;
		actp->wait = 0;
		shot_level = 2;
		shot_max = 16;
		shot_cnt = 0;
		shot_wait = 0;
		shot_bomb = 0;
		ACTnextStep();
		break;

	/* C */
	case 1:
		actp->pos[X] = 320.0f;
		actp->pos[Y] = 480.0f - 64.0f;
		ACTnextStep();
		/*FALLTHRU*/
	case 2:
		if(!time_left) {
			actp->actid = ACTF_MUTEKI;
			ACTsetStep(12);
			break; /* ܂ */
		}
		/* ړ */
		keydat = KEYdat;
		keydir = tstFLG(keydat, KEYDIR);
		actp->pos[X] += mov_tbl[keydir][X];
		actp->pos[Y] += mov_tbl[keydir][Y];
		if(actp->pos[X] < (128.0f+16.0f)) {
			actp->pos[X] = (128.0f+16.0f);
		}
		if(actp->pos[X] > (640.0f-128.0f-16.0f)) {
			actp->pos[X] = (640.0f-128.0f-16.0f);
		}
		if(actp->pos[Y] < 24.0f) {
			actp->pos[Y] = 24.0f;
		}
		if(actp->pos[Y] > (480.0f-12.0f)) {
			actp->pos[Y] = (480.0f-12.0f);
		}
		/* Vbg */
		if(shot_wait) {
			shot_wait--;
		}
		if(!shot_wait && tstFLG(keydat, PAD_INPUT_A)) {
			if((shot_cnt + shot_level) <= shot_max) {
				switch(shot_level) {
				case 2:
					eactp = ACTsetBtm(actShipBullet, GROUP_SSHOT);
					eactp->pos[X] = actp->pos[X] - 8.0f;
					eactp->pos[Y] = actp->pos[Y] - 4.0f;
					eactp->prog_adr(eactp);
					eactp = ACTsetBtm(actShipBullet, GROUP_SSHOT);
					eactp->pos[X] = actp->pos[X] + 8.0f;
					eactp->pos[Y] = actp->pos[Y] - 4.0f;
					eactp->prog_adr(eactp);
					break;
				case 3:
					eactp = ACTsetBtm(actShipBullet, GROUP_SSHOT);
					eactp->pos[X] = actp->pos[X] - 12.0f;
					eactp->pos[Y] = actp->pos[Y] - 4.0f;
					eactp->prog_adr(eactp);
					eactp = ACTsetBtm(actShipBullet, GROUP_SSHOT);
					eactp->pos[X] = actp->pos[X] + 0.0f;
					eactp->pos[Y] = actp->pos[Y] - 4.0f;
					eactp->prog_adr(eactp);
					eactp = ACTsetBtm(actShipBullet, GROUP_SSHOT);
					eactp->pos[X] = actp->pos[X] + 12.0f;
					eactp->pos[Y] = actp->pos[Y] - 4.0f;
					eactp->prog_adr(eactp);
					break;
				case 4:
					eactp = ACTsetBtm(actShipBullet, GROUP_SSHOT);
					eactp->pos[X] = actp->pos[X] - 18.0f;
					eactp->pos[Y] = actp->pos[Y] - 4.0f;
					eactp->prog_adr(eactp);
					eactp = ACTsetBtm(actShipBullet, GROUP_SSHOT);
					eactp->pos[X] = actp->pos[X] + 6.0f;
					eactp->pos[Y] = actp->pos[Y] - 4.0f;
					eactp->prog_adr(eactp);
					eactp = ACTsetBtm(actShipBullet, GROUP_SSHOT);
					eactp->pos[X] = actp->pos[X] - 6.0f;
					eactp->pos[Y] = actp->pos[Y] - 4.0f;
					eactp->prog_adr(eactp);
					eactp = ACTsetBtm(actShipBullet, GROUP_SSHOT);
					eactp->pos[X] = actp->pos[X] + 18.0f;
					eactp->pos[Y] = actp->pos[Y] - 4.0f;
					eactp->prog_adr(eactp);
					break;
				}
				shot_cnt += shot_level;
				shot_wait = 3;
			}
		}
		/* { */
		if(bomb && !shot_bomb && tstFLG(keydat, PAD_INPUT_B)) {
			bomb--;
			shot_bomb = 1;
			ACTsetBtm(actShipBomb, GROUP_SSHOT);
			actp->actid |= ACTF_MUTEKI;
			actp->wait = 60;
		}
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		pos[X] -= 5 * 9 / 2;
		pos[Y] -= 24;
		if(actp->wait) {
			actp->wait--;
			color = 1;
		} else {
			actp->actid &= ~ACTF_MUTEKI;
			color = 0;
		}
		DrawString(pos[X], pos[Y], "  A  ", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "<{O}>", color); pos[Y] += 16;
		if(keydir & PAD_INPUT_LEFT) {
			if(frame & 0x02) {
				DrawString(pos[X], pos[Y], " w W ", color);
			} else {
				DrawString(pos[X], pos[Y], " v V ", color);
			}
		} else if(keydir & PAD_INPUT_RIGHT) {
			if(frame & 0x02) {
				DrawString(pos[X], pos[Y], " W w ", color);
			} else {
				DrawString(pos[X], pos[Y], " V v ", color);
			}
		} else {
			if(frame & 0x02) {
				DrawString(pos[X], pos[Y], " W W ", color);
			} else {
				DrawString(pos[X], pos[Y], " V V ", color);
			}
		}
		break;

	/* SEFCg */
	case 10:
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		pos[X] -= 5 * 9 / 2;
		pos[Y] -= 24;
		color = 1;
		DrawString(pos[X], pos[Y], "  A  ", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "<{O}>", color); pos[Y] += 16;
		if(frame & 0x02) {
			DrawString(pos[X], pos[Y], " W W ", color);
		} else {
			DrawString(pos[X], pos[Y], " V V ", color);
		}
		if(actp->wait) {
			actSetExplode(actp);
			actp->wait--;
		} else {
			if(left >= 0) {
				actp->wait = 30;
				ACTnextStep();
			} else {
				game_mode = -1;
				ACTsetStep(255);
			}
		}
		break;
	case 11:
		if(actp->wait) {
			actp->wait--;
		} else {
			actp->actid |= ACTF_SHIP;
			actp->wait = 120;
			actp->step = 1;
		}
		break;

	/* ^CI[o[ */
	case 12:
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		pos[X] -= 5 * 9 / 2;
		pos[Y] -= 24;
		color = 1;
		DrawString(pos[X], pos[Y], "  A  ", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "<{O}>", color); pos[Y] += 16;
		if(frame & 0x02) {
			DrawString(pos[X], pos[Y], " W W ", color);
		} else {
			DrawString(pos[X], pos[Y], " V V ", color);
		}
		break;

	/* Q[I[o[ */
	case 255:
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}

	return;
}

static void
actShipInt(ACT* actp)
{
	ACT* eactp = actp->ext_dat;

	if(eactp->actid & (ACTF_ENEMY|ACTF_ESHOT)) {
		soundPlaySe(SE_EXP03);
		actp->actid &= ~ACTF_SHIP;
		left--;
		actp->actid |= ACTF_MUTEKI;
		actp->step = 10;
		actp->wait = 30;
		shot_level = 2;
		shot_max = 16;
		rankAdd(-0.25f);
		if(left >= 0) {
			if(bomb < 3) {
				bomb = 3;
			}
		}
	} else if(eactp->actid & ACTF_CHIP) {
		if(!eactp->cnt) {
			switch(shot_level) {
			case 2:
				shot_level++;
				shot_max = 24;
				rankAdd(0.050f);
				break;
			case 3:
				shot_level++;
				shot_max = 32;
				rankAdd(0.075f);
				break;
			default:
				score += 10;
				break;
			}
			soundPlaySe(SE_POWER);
			actp->actid |= ACTF_MUTEKI;
			actp->wait = 60;
			actp->step = 2;
		} else {
			soundPlaySe(SE_GETBOMB);
			if(bomb < 5) {
				bomb++;
				rankAdd(0.025f);
			} else {
				score += 10;
			}
		}
	}
}

static void
actShipBullet(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_SSHOT;
		actp->energy = 1;
		actp->int_adr = actShipBulletInt;
		actp->col[X] = 1 *  9;
		actp->col[Y] = 2 * 16;
		actp->vel[Y] = -14.0f;
		actSetShipParticle(actp);
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		actp->pos[Y] += actp->vel[Y];
		if(actp->pos[Y] < -16.0f) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		pos[X] -= 1 * 9 / 2;
		pos[Y] -= 16;
		DrawString(pos[X], pos[Y], "|", 0); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "!", 0);
		break;

	/* I */
	default:
		shot_cnt--;
		ACTclear(actp);
		break;
	}
}

static void
actShipBulletInt(ACT* actp)
{
	ACTexitStep();
}

static void
actSetShipParticle(ACT* actp)
{
	int lp1;
	ACT* eactp;

	for(lp1 = 0; lp1 < 2; lp1++) {
		eactp = ACTsetBtm(actShipParticle, GROUP_EFFECT);
		eactp->pos[X] = actp->pos[X];
		eactp->pos[Y] = actp->pos[Y];
		eactp->prog_adr(eactp);
	}
}

static void
actSetExplode(ACT* actp)
{
	ACT* eactp;

	eactp = ACTsetBtm(actExplode, GROUP_07);
	eactp->pos[X] = actp->pos[X];
	eactp->pos[Y] = actp->pos[Y];
	eactp->prog_adr(eactp);
}

static void
actShipBomb(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		soundPlaySe(SE_BOMB);
		actp->actid = ACTF_BOMB;
		actp->energy = 1;
		actp->pos[X] = 320.0f;
		actp->pos[Y] = 240.0f;
		actp->col[X] = 640.0f - (128.0f * 2.0f);
		actp->col[Y] = 480.0f;
		actp->cnt = 0;
		actp->wait = 60;
		ACTnextStep();
		break;

	/* C */
	case 1:
		if(actp->wait) {
			actp->wait--;
		} else {
			ACTexitStep();
			shot_bomb = 0;
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		pos[X] -= 48 *  9 / 2;
		pos[Y] -= 16 * 30 / 2;
		switch(actp->cnt % 4) {
		case 0:
			DrawString(pos[X], pos[Y], "                OOOOOOOOOOOOOOOO                ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "             OOOOOOOOOOOOOOOOOOOOOO             ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "          OOOOOOOOOOOOOOOOOOOOOOOOOOOO          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "       OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO       ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "     OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO     ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "     OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO     ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "       OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO       ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "          OOOOOOOOOOOOOOOOOOOOOOOOOOOO          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "             OOOOOOOOOOOOOOOOOOOOOO             ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "                OOOOOOOOOOOOOOOO                ", 1);
			break;
		case 1:
			DrawString(pos[X], pos[Y], "                ****************                ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "             **********************             ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "          ****************************          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "       **********************************       ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "     **************************************     ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ******************************************   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ******************************************   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ********************************************  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ********************************************  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " *********************************************  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " *********************************************  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " ********************************************** ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " ********************************************** ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "************************************************", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "************************************************", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "************************************************", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "************************************************", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " ********************************************** ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " ********************************************** ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " *********************************************  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " *********************************************  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ********************************************  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ********************************************  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ******************************************   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ******************************************   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "     **************************************     ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "       **********************************       ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "          ****************************          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "             **********************             ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "                ****************                ", 1);
			break;
		case 2:
			DrawString(pos[X], pos[Y], "                ++++++++++++++++                ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "             ++++++++++++++++++++++             ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "          ++++++++++++++++++++++++++++          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "       ++++++++++++++++++++++++++++++++++       ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "     ++++++++++++++++++++++++++++++++++++++     ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ++++++++++++++++++++++++++++++++++++++++++   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ++++++++++++++++++++++++++++++++++++++++++   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ++++++++++++++++++++++++++++++++++++++++++++  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ++++++++++++++++++++++++++++++++++++++++++++  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " +++++++++++++++++++++++++++++++++++++++++++++  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " +++++++++++++++++++++++++++++++++++++++++++++  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " ++++++++++++++++++++++++++++++++++++++++++++++ ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " ++++++++++++++++++++++++++++++++++++++++++++++ ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "++++++++++++++++++++++++++++++++++++++++++++++++", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "++++++++++++++++++++++++++++++++++++++++++++++++", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "++++++++++++++++++++++++++++++++++++++++++++++++", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "++++++++++++++++++++++++++++++++++++++++++++++++", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " ++++++++++++++++++++++++++++++++++++++++++++++ ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " ++++++++++++++++++++++++++++++++++++++++++++++ ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " +++++++++++++++++++++++++++++++++++++++++++++  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], " +++++++++++++++++++++++++++++++++++++++++++++  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ++++++++++++++++++++++++++++++++++++++++++++  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ++++++++++++++++++++++++++++++++++++++++++++  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ++++++++++++++++++++++++++++++++++++++++++   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ++++++++++++++++++++++++++++++++++++++++++   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "     ++++++++++++++++++++++++++++++++++++++     ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "       ++++++++++++++++++++++++++++++++++       ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "          ++++++++++++++++++++++++++++          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "             ++++++++++++++++++++++             ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "                ++++++++++++++++                ", 1);
			break;
		case 3:
			DrawString(pos[X], pos[Y], "                                ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "                          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "                    ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "              ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "      ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "      ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "    ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "    ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "  ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "   ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "    ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "    ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "      ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "      ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "              ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "                    ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "                          ", 1); pos[Y] += 16;
			DrawString(pos[X], pos[Y], "                                ", 1);
			break;
		}
		actp->cnt++;
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actShipParticle(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->vel[X] = (rand() % (int)(FVAL * 6) - (FVAL * 3)) / FVAL;	/* -3.00`+2.99 */
		actp->vel[Y] = (rand() % (int)(FVAL * 3) + (FVAL * 1)) / FVAL;	/* +1.00`+3.99 */
		actp->wait = 30;
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		actp->pos[X] += actp->vel[X];
		actp->pos[Y] += actp->vel[Y];
		if(actp->wait) {
			actp->wait--;
		} else {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X] - (1 *  9 / 2);
		pos[Y] = scr_pos[Y] + actp->pos[Y] - (1 * 16 / 2);
		DrawString(pos[X], pos[Y], "", 1);
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actExplode(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->vel[X] = (rand() % (int)(FVAL * 8) - (FVAL * 4)) / FVAL;	/* -4.00`+3.99 */
		actp->vel[Y] = (rand() % (int)(FVAL * 8) - (FVAL * 4)) / FVAL;	/* -4.00`+3.99 */
		actp->wait = 60;
		actp->cnt = 0;
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		actp->pos[X] += actp->vel[X];
		actp->pos[Y] += actp->vel[Y];
		if(actp->wait) {
			actp->wait--;
		} else {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X] - (1 *  9 / 2);
		pos[Y] = scr_pos[Y] + actp->pos[Y] - (1 * 16 / 2);
		if(actp->cnt & 0x04) {
			DrawString(pos[X], pos[Y], "+", 1);
		} else if(actp->cnt & 0x02) {
			DrawString(pos[X], pos[Y], "X", 1);
		} else {
			DrawString(pos[X], pos[Y], "*", 1);
		}
		actp->cnt++;
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

