/*==========================================================================
 *
 *  Copyright (C) 2003 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:bulletcommand.c
 *  Content	:BulletMLR}h֘A
 *  Program	:J.Issiki
 *  Date	:2003/8/25
 *  UpDate	:2004/2/4
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

#define ROTVAL	(180.0f / M_PI)

static void
BulletCommand_createBullet(void* userData, fixed dir, fixed spd, BulletMLNode* bulletNode, const fixed params[/*BULLETML_MAX_PARAMS*/])
{
	ACT* actp = userData;
	ACT* eactp = ACTsetBtm(actEnemyBullet, GROUP_ESHOT);
	float _dir = fst(dir);
	float _spd = fst(spd);
	_dir /= ROTVAL;
	eactp->pos[X] = actp->pos[X];
	eactp->pos[Y] = actp->pos[Y];
	eactp->bul_vel[X] = sin(_dir) * (+_spd);
	eactp->bul_vel[Y] = cos(_dir) * (-_spd);
	eactp->bul_vel[W] = _spd;
	eactp->bul_acc[X] = actp->bul_acc[X];
	eactp->bul_acc[Y] = actp->bul_acc[Y];
	eactp->bul_rot[W] = _dir;
	eactp->bullet = BulletMLBullet_new(&BulletCommand, eactp, bulletNode, params);
}

static void
BulletCommand_setDirection(void* userData, fixed dir)
{
	ACT* actp = userData;
	actp->bul_rot[W] = fst(dir) / ROTVAL;
}

static void
BulletCommand_setSpeed(void* userData, fixed spd)
{
	ACT* actp = userData;
	actp->bul_vel[W] = fst(spd);
}

static void
BulletCommand_setAccelH(void* userData, fixed accH)
{
	ACT* actp = userData;
	actp->bul_acc[X] = fst(accH);
}

static void
BulletCommand_setAccelV(void* userData, fixed accV)
{
	ACT* actp = userData;
	actp->bul_acc[Y] = fst(accV);
}

static void
BulletCommand_vanish(void* userData)
{
	ACT* actp = userData;
	actp->actid |= ACTF_DELETE;
}

static fixed
BulletCommand_getRand(void* userData)
{
	return FRND(seed);
}

static fixed
BulletCommand_getRank(void* userData)
{
	return fld(rank);
}

static fixed
BulletCommand_getAimDirection(void* userData)
{
	ACT* actp = userData;
	float pos[XY];
	float rot;
	BulletMLgetShipDist(actp, pos);
	rot = atan2(pos[X], pos[Y]);
	return fld(rot * ROTVAL);
}

static fixed
BulletCommand_getDirection(void* userData)
{
	ACT* actp = userData;
	return fld(actp->bul_rot[W] * ROTVAL);
}

static fixed
BulletCommand_getSpeed(void* userData)
{
	ACT* actp = userData;
	return fld(actp->bul_vel[W]);
}

static fixed
BulletCommand_getAccelH(void* userData)
{
	ACT* actp = userData;
	return fld(actp->bul_acc[X]);
}

static fixed
BulletCommand_getAccelV(void* userData)
{
	ACT* actp = userData;
	return fld(actp->bul_acc[Y]);
}

const BulletMLUserFunc BulletCommand = {
	.createBullet    = BulletCommand_createBullet,
	.setDirection    = BulletCommand_setDirection,
	.setSpeed        = BulletCommand_setSpeed,
	.setAccelH       = BulletCommand_setAccelH,
	.setAccelV       = BulletCommand_setAccelV,
	.vanish	         = BulletCommand_vanish,
	.getRand         = BulletCommand_getRand,
	.getRank         = BulletCommand_getRank,
	.getAimDirection = BulletCommand_getAimDirection,
	.getDirection    = BulletCommand_getDirection,
	.getSpeed        = BulletCommand_getSpeed,
	.getAccelH       = BulletCommand_getAccelH,
	.getAccelV       = BulletCommand_getAccelV,
};

