/*==========================================================================
 *
 *  Copyright (C) 2001 Jumpie Isshiki. All Rights Reserved.
 *
 *  File	:start.cpp
 *  Content	:WindowsX^[gAbv
 *  Program	:J.Issiki
 *  Date	:2001/6/24
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void BulletMLInit();
static void ClsDrawScreen();
static void CollisionCheck();
static int CollisionCheckSub(ACT* actp, ACT* eactp);
static void GetKeyData();

void
app_main()
{
	/* BulletMLǂݍ */
	BulletMLInit();

	/* ANg */
	ACTinit();
	ACTsetBtm(actMain, GROUP_00);

	/* C[v */
	for(;;) {
		schedule();
		ClsDrawScreen();

		/* L[͎擾 */
		GetKeyData();

		/* I */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* ANgs */
		ACTexec();

		/* RW`FbN */
		CollisionCheck();

		frame++;
	}
}

static void
BulletMLInit()
{
	extern const unsigned char XML_ENEMY01[];
	extern const unsigned char XML_ENEMY02[];
	extern const unsigned char XML_ENEMY03[];
	extern const unsigned char XML_ENEMY04[];
	extern const unsigned char XML_ENEMY05[];
	extern const unsigned char XML_ENEMY06[];
	extern const unsigned char XML_ENEMY07[];
	extern const unsigned char XML_ENEMY08[];
	extern const unsigned char XML_BOSS0101[];
	extern const unsigned char XML_BOSS0102[];
	extern const unsigned char XML_BOSS0201[];
	extern const unsigned char XML_BOSS0202[];
	static const unsigned char* const tbl[BULLETML_MAX][2] = {
		{ "enemy01.xml",  XML_ENEMY01  },
		{ "enemy02.xml",  XML_ENEMY02  },
		{ "enemy03.xml",  XML_ENEMY03  },
		{ "enemy04.xml",  XML_ENEMY04  },
		{ "enemy05.xml",  XML_ENEMY05  },
		{ "enemy06.xml",  XML_ENEMY06  },
		{ "enemy07.xml",  XML_ENEMY07  },
		{ "enemy08.xml",  XML_ENEMY08  },
		{ "boss0101.xml", XML_BOSS0101 },
		{ "boss0102.xml", XML_BOSS0102 },
		{ "boss0201.xml", XML_BOSS0201 },
		{ "boss0202.xml", XML_BOSS0202 },
	};
	int i;
	int y = 4;

	render_printf(&render, (4* 1), y, 0x82, 0, "INIT BULLETML"); update(); y += 6;
	for(i = 0; i < BULLETML_MAX; i++) {
		render_printf(&render, (4* 1), y, 0x82, 0, "LOAD %s", tbl[i][0]); update();
		BulletMLreadFiles(i, tbl[i][1]);
		render_printf(&render, (4*19), y, 0x82, 0, "OK"                ); update(); y += 6;
	}
}

static void
ClsDrawScreen()
{
	memset(vbuff + DISP_X*4, 3, DISP_X*(DISP_Y-8));
}

static void
CollisionCheck()
{
	int group;
	ACT* actp;
	ACT* eactp;

	/* SANg[v */
	for(group = 0; group < ACT_GROUP_MAX; group++) {
		for(actp = ActIndex[group][ACT_TOP].next_act;
		    actp != &ActIndex[group][ACT_BOTTOM];
		    actp = actp->next_act) {
			/* ɂ镪 */
			switch(get_cflag(actp)) {
			case ACTF_SHIP:
				for(eactp = ActIndex[GROUP_ENEMY][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ENEMY][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ENEMY:
						if(!(actp->actid & ACTF_MUTEKI)) {
							if(CollisionCheckSub(actp, eactp)) {
								actp->ext_dat = eactp;
								if(actp->int_adr) {
									actp->int_adr(actp);
								}
								goto L_NEXT;
							}
						}
						break;
					case ACTF_CHIP:
						if(CollisionCheckSub(actp, eactp)) {
							actp->ext_dat = eactp;
							eactp->ext_dat = actp;
							if(actp->int_adr) {
								actp->int_adr(actp);
							}
							if(eactp->int_adr) {
								eactp->int_adr(eactp);
							}
						}
						break;
					}
				}
				for(eactp = ActIndex[GROUP_ESHOT][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ESHOT][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ESHOT:
						if(!(actp->actid & ACTF_MUTEKI)) {
							if(CollisionCheckSub(actp, eactp)) {
								actp->ext_dat = eactp;
								if(actp->int_adr) {
									actp->int_adr(actp);
								}
								goto L_NEXT;
							}
						}
						break;
					}
				}
				break;
			case ACTF_SSHOT:
				for(eactp = ActIndex[GROUP_ENEMY][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ENEMY][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ENEMY:
						if(CollisionCheckSub(actp, eactp)) {
							actp->ext_dat = eactp;
							eactp->ext_dat = actp;
							if(eactp->int_adr) {
								eactp->int_adr(eactp);
							}
							if(actp->int_adr) {
								actp->int_adr(actp);
							}
							goto L_NEXT;
						}
						break;
					}
				}
				break;
			case ACTF_BOMB:
				for(eactp = ActIndex[GROUP_ENEMY][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ENEMY][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ENEMY:
						if(CollisionCheckSub(actp, eactp)) {
							eactp->ext_dat = actp;
							if(eactp->int_adr) {
								eactp->int_adr(eactp);
							}
						}
						break;
					}
				}
				for(eactp = ActIndex[GROUP_ESHOT][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ESHOT][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ESHOT:
						if(CollisionCheckSub(actp, eactp)) {
							eactp->ext_dat = actp;
							if(eactp->int_adr) {
								eactp->int_adr(eactp);
							}
						}
						break;
					}
				}
				break;
			}
L_NEXT:
		}
	}
}

static int
CollisionCheckSub(ACT* actp, ACT* eactp)
{
#define srect_left   (spos[X] - (scol[X] / 2))
#define srect_right  (spos[X] + (scol[X] / 2))
#define srect_top    (spos[Y] - (scol[Y] / 2))
#define srect_bottom (spos[Y] + (scol[Y] / 2))
#define trect_left   (tpos[X] - (tcol[X] / 2))
#define trect_right  (tpos[X] + (tcol[X] / 2))
#define trect_top    (tpos[Y] - (tcol[Y] / 2))
#define trect_bottom (tpos[Y] + (tcol[Y] / 2))

	const float* spos = actp->pos;
	const float* scol = actp->col;
	const float* tpos = eactp->pos;
	const float* tcol = eactp->col;

	if(srect_left > trect_right) return FALSE;
	if(trect_left > srect_right) return FALSE;
	if(srect_top > trect_bottom) return FALSE;
	if(trect_top > srect_bottom) return FALSE;

	return TRUE;

#undef srect_left
#undef srect_right
#undef srect_top
#undef srect_bottom
#undef trect_left
#undef trect_right
#undef trect_top
#undef trect_bottom
}

static void
GetKeyData()
{
	KEYdat = 0;
	if(joy & PAD_DN) KEYdat |= PAD_INPUT_DOWN;
	if(joy & PAD_LF) KEYdat |= PAD_INPUT_LEFT;
	if(joy & PAD_RI) KEYdat |= PAD_INPUT_RIGHT;
	if(joy & PAD_UP) KEYdat |= PAD_INPUT_UP;
	if(joy & PAD_A ) KEYdat |= PAD_INPUT_A;
	if(joy & PAD_B ) KEYdat |= PAD_INPUT_B;

	KEYtrg = 0;
	if(joy & TRG_DN) KEYtrg |= PAD_INPUT_DOWN;
	if(joy & TRG_LF) KEYtrg |= PAD_INPUT_LEFT;
	if(joy & TRG_RI) KEYtrg |= PAD_INPUT_RIGHT;
	if(joy & TRG_UP) KEYtrg |= PAD_INPUT_UP;
	if(joy & TRG_A ) KEYtrg |= PAD_INPUT_A;
	if(joy & TRG_B ) KEYtrg |= PAD_INPUT_B;
}

